/*
 * Copyright (c) 1995, 1995, 1996, 1997, 1998, 1999 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#pragma ident   "@(#)WmMain.c 1.22 99/01/26 SMI; TSOL 2.x"

/* 
 * (c) Copyright 1989, 1990, 1991, 1992 OPEN SOFTWARE FOUNDATION, INC. 
 * ALL RIGHTS RESERVED 
*/ 
/* 
 * Motif Release 1.2.1
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: WmMain.c /main/cde1_maint/2 1995/10/09 13:44:37 pascale $"
#endif
#endif
/*
 * (c) Copyright 1987, 1988, 1989, 1990 HEWLETT-PACKARD COMPANY */

/*
 * Included Files:
 */

#include "WmGlobal.h"

#ifndef NO_MULTIBYTE
#include <locale.h>
#endif
#ifdef WSM
#include <Dt/Message.h>
#include <Dt/EnvControl.h>
#endif /* WSM */
/*
 * include extern functions
 */

#include "WmCEvent.h"
#include "WmEvent.h"
#include "WmInitWs.h"
#ifdef WSM
#include "WmIPC.h"
#include "WmBackdrop.h"
#endif /* WSM */

#ifdef TSOL
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/StringDefs.h>
#include <Xm/Xm.h>
#include <Xm/CascadeB.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/MessageB.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Text.h>
#include <Xm/ToggleB.h>
#include <Xm/SeparatoG.h>
#include <Xm/ToggleBG.h>
#include <stdio.h>
#include <Dt/xpm.h>
#include <bsm/auditwrite.h>
#include <bsm/audit_uevents.h>
#include <tsol/tsol.h>
#include <tsol/user.h>
#include <tsol/prof.h>   
#include <tsol/auth.h>   
#include <tsol/auth_names.h>   
#include <tsol/secconf.h>   
#include <tsol/priv.h>
#include <tsol/pattr.h>
#include "DataBaseLoad.h"
#include "dtb_utils.h"

Widget stripe 		    = (Widget) NULL;
static Widget stripe_form 	    = (Widget) NULL;
static Widget ss_key_iil 	    = (Widget) NULL;
static Widget ss_point_sl 	= (Widget) NULL;
Widget role_dialog = (Widget) NULL;
Widget role_msgbox = (Widget) NULL;
static Widget role_rc = (Widget) NULL;
Widget pass_label = (Widget) NULL;
Widget pass_text = (Widget) NULL;
Widget role_err_label = (Widget) NULL;

char **environ2;
char *rolePasswd;
Boolean tsol_il_enabled; 	/* System wide il enabled or not */
AuditInfo audit_info;		/* Auditing information used by auditwrite */

extern uid_t	AssumeRoleID;
extern Auth_action auth_mode;
extern  bslabel_t   new_ws_sl;
void get_audit_info();
/*
 * Privilege bracketing
 */
#define ALLTIME_PRIVSTR "win_colormap,win_config,win_dac_read,win_dac_write,\
win_devices,win_downgrade_il,win_downgrade_sl,win_fontpath,win_mac_read,\
win_mac_write,win_nofloat,win_selection,win_upgrade_il,win_upgrade_sl,\
proc_setid,proc_setsl,proc_setil,proc_tranquil,sys_trans_label,\
file_dac_read,file_dac_search,proc_audit_appl"

#endif /* TSOL */

/*
 * Function Declarations:
 */
#ifdef WSM
#ifdef _NO_PROTO
int WmReturnIdentity();
#else /* _NO_PROTO */
int WmReturnIdentity (int argc, char *argv[], char *environ[]);
#endif /* _NO_PROTO */
#define ManagedRoot(w) (!XFindContext (DISPLAY, (w), wmGD.screenContextType, \
(caddr_t *)&pSD) ? (SetActiveScreen (pSD), True) : \
(IsBackdropWindow (ACTIVE_PSD, (w))))
#else /* WSM */
#define ManagedRoot(w) (!XFindContext (DISPLAY, (w), wmGD.screenContextType, \
(caddr_t *)&pSD) ? (SetActiveScreen (pSD), True) : False)
#endif /* WSM */

WmScreenData *pSD;

/*
 * Global Variables:
 */

WmGlobalData wmGD;
#ifdef MESSAGE_CAT
NlsStrings wmNLS;
#endif /* MESSAGE_CAT */
#ifdef WSM
int WmIdentity;
#endif /* WSM */



/*************************************<->*************************************
 *
 *  main (argc, argv, environ)
 *
 *
 *  Description:
 *  -----------
 *  This is the main window manager function.  It calls window manager
 *  initializtion functions and has the main event processing loop.
 *
 *
 *  Inputs:
 *  ------
 *  argc = number of command line arguments (+1)
 *
 *  argv = window manager command line arguments
 *
 *  environ = window manager environment
 *
 *************************************<->***********************************/

#ifdef _NO_PROTO
int
main (argc, argv, environ)
    int argc;
    char *argv[];
    char *environ[];

#else /* _NO_PROTO */
int
main (int argc, char *argv [], char *environ [])
#endif /* _NO_PROTO */
{
    XEvent	event;
    Boolean	dispatchEvent;
    userent_t	*u;
    int		idle_time;


#ifdef TSOL
    priv_set_t  priv_set;
#ifdef DEBUG
	/* for debug-purpose only */
	{
		int	loop_forever = 0;
		while (loop_forever == 1)
		{
			sleep (10);
		}
	}
#endif /* DEBUG */
        environ2 = environ;
 {
	char *user_min_sl;
	char *user_max_sl;
	int	 tran_error;
	int  errorcode=0;
	char *username;
	struct passwd 	*p;
        /*
         * Turn on required privs
         */
#ifdef DEBUG
        setpattr(PAF_PRIV_DBG, PAF_TP_ON);
#endif /* DEBUG */
	/* priv bracketing tbd later
        str_to_priv_set(ALLTIME_PRIVSTR, &priv_set, ",");
        setppriv(PRIV_SET, PRIV_EFFECTIVE, &priv_set);
	*/

	/* Check if system wide IL is enabled */
	if(secconf(_TSOL_ENABLE_IL))
		tsol_il_enabled = True;
	else
	       	tsol_il_enabled = False;

	bcllow(&wmGD.admin_low);
	if ( (username = getenv("USER")) == NULL)
	    wmGD.errorFlag = True;
	p = &wmGD.User[0].p;

	p = getpwnam_r(username, p, wmGD.User[0].pw_buffer, PW_BUF_LEN);
	if ((u = wmGD.User[0].u = getuserentbyname(username, TSOL_DB_SRC_SWITCH)) == NULL) {
	    wmGD.errorFlag = True;
	}
	user_min_sl = getenv ("USER_MIN_SL");
	user_max_sl = getenv ("USER_MAX_SL");

	if (!htobsl(user_min_sl, &wmGD.session_minlabel))
	{
	   errorcode=1;
	}
	if (!htobclear(user_max_sl, &wmGD.session_clearance))
	{
	   errorcode=1;
	}
	wmGD.User[0].saved_passwd = (char*)NULL;
	wmGD.User[0].do_accred_check 
	  = chkauth(TSOL_AUTH_SYS_ACCRED_SET, u->name) == 1 ?
		False : True;

	wmGD.UserCount = 1;

	/* Process the /etc/default/login file */
	(void) tsol_login_defaults();

    }
#endif /* TSOL */

    setlocale(LC_ALL, "");
#ifdef __osf__
    svc_init();
#endif

#ifndef NO_MULTIBYTE
#ifdef WSM
    /*
     * Set up environment variables for this HP DT client
     */
    _DtEnvControl(DT_ENV_SET);

    /*
     * Force LANG lookup early. 
     * (Front end may change $LANG to 'C' as part
     *  of string space reduction optimization.)
     */
     {
	 char * foo = ((char *)GETMESSAGE(44, 1, ""));
     }
#endif /* WSM */
    XtSetLanguageProc (NULL, (XtLanguageProc)NULL, NULL);
#endif
#ifdef WSM
    /*  
     * Get Identity
     */
    WmIdentity = WmReturnIdentity(argc, argv, environ);
#endif /* WSM */

    /*
     * Initialize the workspace:
     */

    InitWmGlobal (argc, argv, environ);
#ifdef WSM

    /*
     * Set up PATH variable if it must run as standalone command
     * invoker
     */
    if (wmGD.dtLite)
    {
	_DtEnvControl(DT_ENV_SET_BIN);
    }
#endif /* WSM */
    
#ifdef TSOL
	(void) get_audit_info();
	InitTsolComponents();
	InitRoleComponents();
	AddMailMonitor();
    
    /* Set the Screen Saver idle time */
#define TIMEOUT_MIN	1
    /* Get the idle time for Screen Saver from userent  */
       idle_time = atoi(u->idletime);  /* This is in minutes */

       if ((idle_time > 0) && (idle_time < TIMEOUT_MIN))
	 idle_time = TIMEOUT_MIN;
 
    /* Register new Screen Saver timeout with X */
      XSetScreenSaver(DISPLAY, (60*idle_time), /* seconds of idle time*/ 
         		0, DontPreferBlanking,DontAllowExposures);
#endif /* TSOL */

    /*
     * MAIN EVENT HANDLING LOOP:
     */

    for (;;)
    {
        XtAppNextEvent (wmGD.mwmAppContext, &event);


        /*
	 * Check for, and process non-widget events.  The events may be
	 * reported to the root window, to some client frame window,
	 * to an icon window, or to a "special" window management window.
	 * The lock modifier is "filtered" out for window manager processing.
	 */

	wmGD.attributesWindow = 0L;

#ifdef WSM
	if ((event.type == ButtonPress) || 
	    (event.type == ButtonRelease))
	{
	    if ((wmGD.evLastButton.button != 0) &&
		ReplayedButtonEvent (&(wmGD.evLastButton), 
				     &(event.xbutton)))
	    {
		wmGD.bReplayedButton = True;
	    }
	    else
	    {
		/* save this button for next comparison */
		memcpy (&wmGD.evLastButton, &event, sizeof (XButtonEvent));
		wmGD.bReplayedButton = False;
	    }
	}
#endif /* WSM */
	dispatchEvent = True;
	if (wmGD.menuActive)
	{
	    /*
	     * Do special menu event preprocessing.
	     */

	    if (wmGD.checkHotspot || wmGD.menuUnpostKeySpec ||
		wmGD.menuActive->accelKeySpecs)
	    {
	        dispatchEvent = WmDispatchMenuEvent ((XButtonEvent *) &event);
	    }
	}

	if (dispatchEvent)
	{
	    if (ManagedRoot(event.xany.window))
	    {
	        dispatchEvent = WmDispatchWsEvent (&event);
	    }
	    else
	    {
	        dispatchEvent = WmDispatchClientEvent (&event);
	    }

	    if (dispatchEvent)
	    {
                /*
                 * Dispatch widget related event:
                 */

                XtDispatchEvent (&event);
	    }
	}
    }

} /* END OF FUNCTION main */

#ifdef WSM
/******************************<->*************************************
 *
 *  WmReturnIdentity (argc, argv, environ)
 *
 *
 *  Description:
 *  -----------
 *  This function checks the last component of the (path)name
 *  contained in argv[0] and makes a global decision as to whether
 *  it should fetch resources as mwm or dtwm.
 *
 *  Inputs:
 *  ------
 *  argc = number of command line arguments (+1)
 *
 *  argv = window manager command line arguments
 *
 *  environ = window manager environment
 *
 ******************************<->***********************************/

#ifdef _NO_PROTO
int WmReturnIdentity (argc, argv, environ)
int argc;
char *argv[];
char *environ[];
#else /* _NO_PROTO */
int WmReturnIdentity ( int argc, char *argv[], char *environ[]) 
#endif /* _NO_PROTO */
{
	char *tempString;
	char *origPtr;

	/* assume it's dtwm until proven differently */

 	int retVal = DT_MWM;

	if (!(tempString = 
	      (char *)(XtMalloc ((unsigned int)(strlen (argv[0]) + 1)))))
	{
		Warning(((char *)GETMESSAGE(44, 2, "Insufficient memory for name of window manager")));
		exit(WM_ERROR_EXIT_VALUE);
	}

	origPtr = tempString;

	if (strrchr(argv[0], '/'))
	{
		
		strcpy(tempString, (strrchr(argv[0], '/')));

		tempString++;
	}
	else
		strcpy(tempString, argv[0]);

	if (!(strcmp(tempString, WM_RESOURCE_NAME)))
	/*
	 *
	 *   If it's explicity "mwm", then set our identity anew.
	 *
	 */
	{
		retVal = MWM;
	}

	XtFree((char *)origPtr);

	return(retVal);

} /* END OF FUNCTION WmReturnIdentity */
#endif /* WSM */
#ifdef WSM
/*************************     eof   ******************************/
#endif /* WSM */




#ifdef TSOL

#ifdef _NO_PROTO
int
AuthenticateRole(User)
WmUser	*User;
#else
int
AuthenticateRole(WmUser *User;
#endif /* _NO_PROTO */
{
	char		*ttyline	= "/dev/console";
	char 		*displayname	= ":0";
	int		status;
	struct passwd	*p = &User->p;
	userent_t	*u = User->u;
	
	AssumeRoleID = p->pw_uid;
	htobsl(u->labelmin, &new_ws_sl);
	status = dtwm_solaris_authenticate("dtwm", displayname, rolePasswd, p->pw_name, ttyline);
	if(status == 0) {
		User->saved_passwd = strdup(rolePasswd);
		auditwrite(AW_SUBJECT, audit_info.auid,audit_info.euid,
			audit_info.egid, audit_info.ruid, audit_info.rgid,
			audit_info.pid, audit_info.sid, &audit_info.tid,
			AW_EVENTNUM, AUE_su,
			AW_TEXT, p->pw_name,
			AW_RETURN, 0, 0,
			AW_WRITE, AW_END);
	}else{
		User->saved_passwd = (char*)NULL;
		auditwrite(AW_SUBJECT, audit_info.auid, audit_info.euid, 
			audit_info.egid, audit_info.ruid, audit_info.rgid,
			audit_info.pid, audit_info.sid, &audit_info.tid,
			AW_EVENTNUM, AUE_su,
			AW_TEXT, p->pw_name,
			AW_RETURN, -1, 0,
			AW_WRITE, AW_END);
	}

	return(status);
}

#ifdef _NO_PROTO
void
PassTextCallback(w, client_data, call_data)
		Widget w;
		XtPointer client_data;
		XtPointer call_data;
#else
void
PassTextCallback(  Widget    w,
               	XtPointer client_data,
               	XtPointer call_data)
#endif /* _NO_PROTO */
{
	int		len;
	char		*new;
	char		*tmp_str;
	XmString	xmstring;
	Arg		args[2];
	int		status;
	XmTextVerifyCallbackStruct *cbs =
		(XmTextVerifyCallbackStruct *) call_data;

	if (cbs->reason == XmCR_VALUE_CHANGED) {
		/*
		XmTextSetInsertionPosition(w, 0);
		*/
		return;
	}

	if (cbs->reason == XmCR_ACTIVATE) {
		status = AuthenticateRole(auth_mode.User);
		if (status == 0) {
			WithdrawDialog(w);
	    		XmTextFieldSetString(pass_text, NULL);
		}
		else {
			rolePasswd[0] = 0;
	    		XmTextFieldSetString(pass_text, NULL);
			XtManageChild(role_err_label);
			cbs->doit = False;
		}
		return;
	}

	if(XtIsManaged(role_err_label)){
	    XtUnmanageChild(role_err_label);
	}
	if (cbs->startPos < cbs->currInsert) { /* Backspace */
		cbs->endPos = strlen(rolePasswd);
		rolePasswd[cbs->startPos] = 0;
		return;
	}

	if (cbs->text->length > 1) { /* don't allow paste operations */
		cbs->doit = False;
		return;
	}

	new = XtMalloc(cbs->endPos + 2); /* new char + NULL terminator */
	if (rolePasswd) {
		strcpy(new, rolePasswd);
		XtFree(rolePasswd);
	}
	else
		new[0] = NULL;
	rolePasswd = new;
	strncat(rolePasswd, cbs->text->ptr, cbs->text->length);
	rolePasswd[cbs->endPos + cbs->text->length] = 0;

	/*  echo * to widget */
	for(len = 0; len < cbs->text->length; len++)
		cbs->text->ptr[len] = ' ';
}


#ifdef _NO_PROTO
void
RoleOKCallback(w, client_data, call_data)
		Widget w;
		XtPointer client_data;
		XtPointer call_data;
#else
void
RoleOKCallback(  Widget    w,
               	XtPointer client_data,
               	XtPointer call_data)
#endif /* _NO_PROTO */
{
	char		*tmp_str;
	XmString	xmstring;
	int		status;

	status = AuthenticateRole(auth_mode.User);
	if (status == 0) {
		WithdrawDialog(w);
		XmTextFieldSetString(pass_text, NULL);
	}
	else {
		XmTextFieldSetString(pass_text, NULL);
		XtManageChild(role_err_label);
	}
}

#ifdef _NO_PROTO
void
RoleCancelCallback(w, client_data, call_data)
		Widget w;
		XtPointer client_data;
		XtPointer call_data;
#else
void
RoleCancelCallback(  Widget    w,
               	XtPointer client_data,
               	XtPointer call_data)
#endif /* _NO_PROTO */
{
	auth_mode.User->saved_passwd = (char*)-1; /* GLENN */
	WithdrawDialog(w);
	XmTextFieldSetString(pass_text, NULL);
}
void
EnterStripeForm(
	Widget w,
	XtPointer client_data,
	XEvent *event)
{
        XmString        str;
        XmFontList      fontlist = ACTIVE_PSD->clientAppearance.fontList;
	Pixel bg, fg;

        if(wmGD.ss_point){

	    str = NULL;
	    if (panel.inactive_pixel_set) {
		    bg = panel.inactive_pixel_set->bg;
		    fg = panel.inactive_pixel_set->fg;
	    } else {
		    /* if front panel is absent  */
		    XtVaGetValues(stripe, XtNbackground, &bg, NULL);
		    XtVaGetValues(ss_point_sl, XtNforeground, &fg, NULL);
	    }
            XtVaSetValues (wmGD.ss_point,
		 XmNlabelString, str,
                 XmNbackground, bg,
                 XmNforeground, fg,
                NULL);

	    XtManageChild(wmGD.ss_key_icon);
	}
}
/* Popup the front panel when any button is pressed on stripe */
void
ButtonPressStripeForm( Widget w, XtPointer client_data, XEvent *event)
{
        F_Expose_Front_Panel(NULL, NULL, event);
}

int InitTsolComponents () 
{
        Display 	*display = XtDisplay ( wmGD.topLevelW1 );
        Widget 		children[6];          /* Children to manage */
        Arg 		al[64];               /* Arg List */
        register int 	ac = 0;               /* Arg Count */
        XrmValue 	from_value, to_value; /* For resource conversion */
        XmString 	xmstrings[16];        /* temporary storage for XmStrings */
	Window		root;
	int		root_x;
	int		root_y;
	int		root_height;
	int		root_width;
	int		root_border_width;
	int		root_depth;
	int		old_root_height;

        XmFontList      fontList = ACTIVE_PSD->clientAppearance.fontList;
	Dimension	ssWidth, ssHeight;
	Dimension	TP_Width = 0;
	Dimension	IIL_Width = 0;
	Dimension	SL_Width = 0;
	Dimension	ScreenStripeHeight;

	wmGD.ss_point = wmGD.ss_key = (Widget)NULL;
	wmGD.ss_key_iil_width = wmGD.ss_point_sl_width = 0;
	XmStringExtent (fontList, wmGD.clientDefaultTitle,
                        &ssWidth, &ssHeight);

	/* Reset screen stripe height to 0 */
	XTSOLsetSSHeight(display, 0, 0);
        ScreenStripeHeight =  (unsigned int) ssHeight +
                  WM_BOTTOM_TITLE_PADDING +
                  4*ICON_EXTERNAL_SHADOW_WIDTH;

	if((tsol_il_enabled && !strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDEIL_KW))
	  ||(!strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDESL_KW))){
		XGetGeometry(display, DefaultRootWindow(display), &root, &root_x, 
			&root_y, & root_width, &root_height, &root_border_width, 
			&root_depth);
		XTSOLsetSSHeight	(display, 0, ScreenStripeHeight);
		old_root_height = root_height;
		XGetGeometry(display, DefaultRootWindow(display), &root, &root_x, 
			&root_y, & root_width, &root_height, &root_border_width, 
			&root_depth);
		if(old_root_height > root_height){
		    ((display)->screens[(0)]).height = old_root_height - ScreenStripeHeight;
		    ((wmGD.display)->screens[(0)]).height = old_root_height - ScreenStripeHeight;
		}
	}
        XtSetArg(al[ac], XmNallowShellResize, False); ac++;
        XtSetArg(al[ac], XtNoverrideRedirect, True); ac++;
        XtSetArg(al[ac], XtNx, 		0); ac++;

	if((tsol_il_enabled && !strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDEIL_KW))
	  ||(!strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDESL_KW))){
        	XtSetArg(al[ac], XtNy,	DisplayHeight(display, 0)); ac++;
		XtSetArg(al[ac], XmNwidth,  DisplayWidth(display, 0)); ac++;
	}else{
        	XtSetArg(al[ac], XtNy,	DisplayHeight(display, 0)
			- ScreenStripeHeight); ac++;
		XtSetArg(al[ac], XmNwidth,  ScreenStripeHeight + 5); ac++;
	}
        XtSetArg(al[ac], XmNheight, ScreenStripeHeight); ac++;
        stripe = XtCreatePopupShell ( "stripe", topLevelShellWidgetClass, wmGD.topLevelW1, al, ac );

        ac = 0;

        if (DefaultDepthOfScreen(DefaultScreenOfDisplay(display)) != 1) {
        	from_value.addr = "LightGoldenrod";
        	from_value.size = strlen( from_value.addr ) + 1;
        	to_value.addr = NULL;
        	XtConvertAndStore (stripe, XmRString, &from_value, XmRPixel, &to_value);
        	if ( to_value.addr )
        	{
                	XtSetArg(al[ac], XmNbackground, *(unsigned int *)to_value.addr); ac++;
        	}
        }
        XtSetValues ( stripe,al, ac );

        ac = 0;

        XtSetArg(al[ac], XmNwidth, DisplayHeight(display, 0)); ac++;
        XtSetArg(al[ac], XmNheight, ScreenStripeHeight); ac++;

#ifdef COLOR
        if (DefaultDepthOfScreen(DefaultScreenOfDisplay(display)) != 1) {
        	from_value.addr = "gold";
        	from_value.size = strlen( from_value.addr ) + 1;
        	to_value.addr = NULL;
        	XtConvertAndStore (stripe, XmRString, &from_value, XmRPixel, &to_value);
        	if ( to_value.addr )
        	{
                	XtSetArg(al[ac], XmNbackground, *(unsigned int *)to_value.addr); ac++;
        	}
        }
#endif /*COLOR*/

        XtSetArg(al[ac], XmNnoResize, TRUE); ac++;
        XtSetArg(al[ac], XmNautoUnmanage, FALSE); ac++;
        XtSetArg(al[ac], XtNoverrideRedirect, True); ac++;
        XtSetArg(al[ac], XtNx, 		0); ac++;
        XtSetArg(al[ac], XtNy, 		DisplayHeight(display, 0)); ac++;
        XtSetArg(al[ac], XmNwidth,  DisplayWidth(display, 0)); ac++;
        XtSetArg(al[ac], XmNheight, ScreenStripeHeight); ac++;
        XtSetArg(al[ac], XmNresizable, 	False); ac++;

        stripe_form = XmCreateForm ( stripe, "stripe_form", al, ac );
        ac = 0;

	XtAddEventHandler(stripe_form, EnterWindowMask, FALSE, (XtEventHandler)EnterStripeForm, NULL);
        XtAddEventHandler(stripe_form, ButtonPressMask, FALSE, (XtEventHandler)ButtonPressStripeForm, NULL);

        wmGD.ss_key_icon = XmCreateLabel ( stripe_form, "ss_key_icon", al, ac );
	{
		char *icon_file;

		xmstrings[0] = XmStringCreate("TP", "bold");
		XmStringExtent (fontList, xmstrings[0], &TP_Width, &ssHeight);
		if(ssHeight > 27)
			icon_file = "TSpath.m.pm";
		else if (ssHeight > 19)
			icon_file = "TSpath.s.pm";
		else
			icon_file = "TSpath.t.pm";
		if(dtb_set_label_from_image_file(wmGD.ss_key_icon, icon_file)
		   < 0){
			TP_Width += 50; /* fudge factore for spacing */
			XtVaSetValues (wmGD.ss_key_icon, 
				 XmNlabelString, xmstrings[0],
				 XmNbackground, panel.inactive_pixel_set->fg,
				 XmNforeground, panel.inactive_pixel_set->bg,
				 NULL);
		
		}else
			TP_Width = ssHeight + 12;
		XmStringFree ( xmstrings [ 0 ] );
	}

        ac = 0;

        XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
        XtSetArg(al[ac], XmNtopOffset, 1); ac++;
        XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
        XtSetArg(al[ac], XmNleftOffset, 6); ac++;
        XtSetValues ( wmGD.ss_key_icon,al, ac );

    if(tsol_il_enabled && !strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDEIL_KW)){
        ac = 0;
        xmstrings[0] = XmStringCreateLocalized(
	    GETMESSAGE(TSET, 5, "Input IL:"));
	XmStringExtent (fontList, xmstrings[0], &IIL_Width, &ssHeight);
        XtSetArg(al[ac], XmNlabelString, xmstrings[0]); ac++;
        ss_key_iil = XmCreateLabel( stripe_form, "ss_key_iil", al, ac );

        ac = 0;
        XmStringFree ( xmstrings [ 0 ] );

#ifdef COLOR
        if (DefaultDepthOfScreen(DefaultScreenOfDisplay(display)) != 1) {
        	from_value.addr = "gold";
        	from_value.size = strlen( from_value.addr ) + 1;
        	to_value.addr = NULL;
        	XtConvertAndStore (stripe_form, XmRString, &from_value, XmRPixel, &to_value);
        	if ( to_value.addr )
        	{
               	 	XtSetArg(al[ac], XmNbackground, *(unsigned int *)to_value.addr); ac++;
        	}
        }
#endif /*COLOR*/

        xmstrings[0] = XmStringCreateLocalized(" ");
        XtSetArg(al[ac], XmNlabelString, xmstrings[0]); ac++;

        wmGD.ss_key = XmCreateLabel(stripe_form,
	    GETMESSAGE(TSET, 4, "Trusted Path"), al, ac );

        ac = 0;

        XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
        XtSetArg(al[ac], XmNtopOffset, 1); ac++;
        XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
        XtSetArg(al[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
        XtSetArg(al[ac], XmNleftOffset, 20); ac++;
        XtSetArg(al[ac], XmNleftWidget, wmGD.ss_key_icon); ac++;
        XtSetArg(al[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
        XtSetValues ( ss_key_iil,al, ac );

        ac = 0;

        XtSetArg(al[ac], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); ac++;
        XtSetArg(al[ac], XmNtopOffset, 0); ac++;
        XtSetArg(al[ac], XmNtopWidget, ss_key_iil); ac++;
        XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_OPPOSITE_WIDGET); ac++;
        XtSetArg(al[ac], XmNbottomOffset, 0); ac++;
        XtSetArg(al[ac], XmNbottomWidget, ss_key_iil); ac++;
        XtSetArg(al[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
        XtSetArg(al[ac], XmNleftOffset, 10); ac++;
        XtSetArg(al[ac], XmNleftWidget, ss_key_iil); ac++;
        XtSetArg(al[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
	if(!strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDESL_KW)){
	    wmGD.ss_key_iil_width = DisplayWidth(display, 0)/2 - TP_Width - IIL_Width;
	}else{
	    wmGD.ss_key_iil_width = DisplayWidth(display, 0) - TP_Width - IIL_Width;
	}
        XtSetValues ( wmGD.ss_key,al, ac );
    }
    if(!strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDESL_KW)){

        ac = 0;
        XmStringFree ( xmstrings [ 0 ] );
        ac = 0;

        xmstrings[0] = XmStringCreateLocalized(
	    GETMESSAGE(TSET, 6, "Window SL:"));
	XmStringExtent (fontList, xmstrings[0], &SL_Width, &ssHeight);
	wmGD.ss_point_sl_width = DisplayWidth(display, 0) - TP_Width - SL_Width
	  - IIL_Width - wmGD.ss_key_iil_width - 10;
        XtSetArg(al[ac], XmNlabelString, xmstrings[0]); ac++;
        ss_point_sl = XmCreateLabel(stripe_form, "ss_point_sl", al, ac );

        ac = 0;
        XmStringFree ( xmstrings [ 0 ] );

#ifdef COLOR
        if (DefaultDepthOfScreen(DefaultScreenOfDisplay(display)) != 1) {
        	from_value.addr = "gold";
        	from_value.size = strlen( from_value.addr ) + 1;
        	to_value.addr = NULL;
        	XtConvertAndStore (stripe_form, XmRString, &from_value, XmRPixel, &to_value);
        	if ( to_value.addr )
        	{
                	XtSetArg(al[ac], XmNbackground, *(unsigned int *)to_value.addr); ac++;
        	}
        }
#endif /*COLOR*/

        xmstrings[0] = XmStringCreateLocalized(" ");
        XtSetArg(al[ac], XmNlabelString, xmstrings[0]); ac++;
        wmGD.ss_point = XmCreateLabel ( stripe_form,
	    GETMESSAGE(TSET, 4, "Trusted Path"), al, ac );

        ac = 0;

        XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM); ac++;
        XtSetArg(al[ac], XmNtopOffset, 1); ac++;
        XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_NONE); ac++;
        XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM); ac++;
	if(!tsol_il_enabled || strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDEIL_KW)){
	    XtSetArg(al[ac], XmNleftWidget, wmGD.ss_key_icon); ac++;
	    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++; 
	    XtSetArg(al[ac], XmNleftOffset, 20); ac++;
	}else{
	    XtSetArg(al[ac], XmNleftWidget, wmGD.ss_key); ac++;
	    XtSetArg(al[ac], XmNleftOffset, DisplayWidth(display, 0)/2 );
	    ac++;
	}
        XtSetArg(al[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
        XtSetValues ( ss_point_sl,al, ac );

        ac = 0;

        XtSetArg(al[ac], XmNtopAttachment, XmATTACH_OPPOSITE_WIDGET); ac++;
        XtSetArg(al[ac], XmNtopOffset, 0); ac++;
        XtSetArg(al[ac], XmNtopWidget, ss_point_sl); ac++;
        XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_OPPOSITE_WIDGET); ac++;
        XtSetArg(al[ac], XmNbottomOffset, 0); ac++;
        XtSetArg(al[ac], XmNbottomWidget, ss_point_sl); ac++;
        XtSetArg(al[ac], XmNleftAttachment, XmATTACH_WIDGET); ac++;
        XtSetArg(al[ac], XmNleftOffset, 10); ac++;
        XtSetArg(al[ac], XmNleftWidget, ss_point_sl); ac++;
        XtSetArg(al[ac], XmNrightAttachment, XmATTACH_NONE); ac++;
        XtSetValues ( wmGD.ss_point,al, ac );

    }
        ac = 0;

        children[ac++] = wmGD.ss_key_icon;
	if(secconf(_TSOL_ENABLE_IL_FLOATING)){
	    if(tsol_il_enabled && !strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDEIL_KW)){
		children[ac++] = ss_key_iil;
		children[ac++] = wmGD.ss_key;
	    }
	}
	if(!strstr(wmGD.User[0].u->labelview, TSOL_USER_VIEW_HIDESL_KW)){
	    children[ac++] = ss_point_sl;
	    children[ac++] = wmGD.ss_point;
	}
        XtManageChildren(children, ac);

        ac = 0;

	XtManageChild (stripe_form);
	XtPopup (stripe, XtGrabNone);
	XTSOLMakeTPWindow	(display, XtWindow(stripe));
	XTSOLsetWorkstationOwner (display, &WorkstationOwner);
	XTSOLsetSessionLO (display, &wmGD.session_minlabel);
	XTSOLsetSessionHI (display, &wmGD.session_clearance);

}



int InitRoleComponents()
{
	Widget children[6];      /* Children to manage */
	Arg al[64];                    /* Arg List */
	register int ac = 0;           /* Arg Count */
	XmString xmstring;    /* temporary storage for XmStrings */
	
	Dimension width;
	Dimension height;
	Dimension screen_width;
	Dimension screen_height;
	int x, y;

  	ac = 0;
  	XtSetArg(al[ac], XmNallowShellResize, False); ac++;
  	XtSetArg(al[ac], XmNmwmDecorations, MWM_DECOR_BORDER);ac++;
  	XtSetArg(al[ac], XmNkeyboardFocusPolicy,(XtArgVal) XmEXPLICIT);  ac++;
  	XtSetArg(al[ac], XmNdialogStyle, XmDIALOG_SYSTEM_MODAL); ac++;
        role_dialog = XtCreatePopupShell ( "role_dialog",
                        transientShellWidgetClass, wmGD.topLevelW1, al, ac );

  	ac = 0;
  	xmstring =XmStringCreateLocalized(
	    GETMESSAGE(TSET, 3, "Role:"));
  	XtSetArg(al[ac],XmNmessageString,xmstring);ac++;
  	XtSetArg(al[ac],XmNdialogType,XmDIALOG_WORKING);ac++;
  	XtSetArg(al[ac], XmNnavigationType,XmEXCLUSIVE_TAB_GROUP); ac++;
  	XtSetArg(al[ac], XmNdefaultButtonType,XmDIALOG_HELP_BUTTON); ac++;
  	XtSetArg (al[ac], XmNresizePolicy, XmRESIZE_ANY); ac++;
  	XtSetArg (al[ac], XmNautoUnmanage, False); ac++;
  	role_msgbox = XmCreateMessageBox(role_dialog,"role_msgbox",al,ac);
  	XmStringFree(xmstring);
 
  	ac = 0;
  	XtSetArg(al[ac],XmNpacking,XmPACK_TIGHT);ac++;
  	XtSetArg(al[ac],XmNadjustLast,True);ac++;
  	role_rc = XmCreateRowColumn (role_msgbox, "role_rc",NULL,0);

	ac = 0;
	xmstring = XmStringCreateLocalized(
	    GETMESSAGE(TSET, 7, "Password:"));
	XtSetArg(al[ac], XmNlabelString, xmstring); ac++;
	XtSetArg(al[ac],XmNtraversalOn,False);ac++;
	pass_label = XmCreateLabel ( role_rc, "pass_label", al, ac );
	XmStringFree (xmstring);

  	ac = 0;
  	XtSetArg (al[ac], XmNeditable, True); ac++;
  	XtSetArg(al[ac], XmNverifyBell,False); ac++;
  	pass_text = (Widget)XmCreateTextField (role_rc, "role_text",al,ac);

	ac = 0;
	xmstring = XmStringCreateLocalized(
	    GETMESSAGE(TSET, 8, "Incorrect Password - Please try again"));
	XtSetArg(al[ac], XmNlabelString, xmstring); ac++;
	role_err_label = XmCreateLabel ( role_rc, "role_err_label", al, ac );
	XmStringFree (xmstring);

	XtAddCallback (pass_text, XmNmodifyVerifyCallback, PassTextCallback,NULL);
	XtAddCallback (pass_text, XmNvalueChangedCallback, PassTextCallback,NULL);

	XtAddCallback (pass_text, XmNactivateCallback, PassTextCallback,NULL);
	XtAddCallback (role_msgbox, XmNokCallback, RoleOKCallback,NULL);
	XtAddCallback (role_msgbox, XmNcancelCallback, RoleCancelCallback,NULL);

	ac =0;
	children[ac++] = pass_label;
	children[ac++] = pass_text;
	children[ac++] = role_err_label;
	XtManageChildren(children, ac);

	XtManageChild ( role_rc);
	XtManageChild ( role_msgbox);

	XtSetSensitive(XmMessageBoxGetChild(role_msgbox,
                                     XmDIALOG_HELP_BUTTON), False);

	XtRealizeWidget(role_dialog);

	/*
	 * Position the role password dialog
	 * at the center of the display
	 */

	XtVaGetValues(role_dialog,
	    XmNwidth, &width,
	    XmNheight, &height,
	    NULL);

	screen_width = DisplayWidth(DISPLAY, ACTIVE_PSD->screen);
	screen_height = DisplayHeight(DISPLAY, ACTIVE_PSD->screen);
	    
	x = ((int)(screen_width - width))/2;
	y = ((int)(screen_height - height))/2;

	XtVaSetValues(role_dialog,
	    XmNx, x,
	    XmNy, y,
	    XmNdefaultPosition, False,
	    NULL);

}
void
get_audit_info()
{
	uid_t workstation_owner;
	struct passwd *pw_ent;

	XTSOLgetWorkstationOwner(DISPLAY, &workstation_owner);
	pw_ent = getpwuid(workstation_owner);
	audit_info.euid = audit_info.ruid = pw_ent->pw_uid;
	audit_info.egid = audit_info.rgid = pw_ent->pw_gid;
	audit_info.auid = audit_info.euid;
	audit_info.pid = getpid();	/* window manager's pid */
	audit_info.sid = audit_info.pid;
	if (cannot_audit(1))
		audit_info.enabled = False;
	else
		audit_info.enabled = True;
	/* set preselection mask for user */
	au_user_mask(pw_ent->pw_name, &audit_info.au_mask);
	auditwrite(AW_SERVER, AW_END);
	auditwrite(AW_PRESELECT, &audit_info.au_mask, AW_END);
}
#endif /* TSOL */
